<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>DMT via SeqInsert Documentation</TITLE>
    </HEAD>

    <BODY>
        <H1 align="center">How to run DMT Test via SeqInsert</H1>

        <P>In an engineering run, the actual dmt triggers are sent via a ligotools program SeqInsert
		via an http like process. This test exercises the method to make sure ldas is compatible
		with actual dmt process; the test objectives are the same as simulated DMT:
		<UL>
		<LI>Ability of ldas to ingest data from external xml formatted by dmt process by retrieving xml from url,
		converting it into ilwd format and inserting the data into the database.</LI><p>
		
		<LI>Account for all the data sent to ldas from dmt: at times there maybe errors obtaining the file from url, or there
		maybe due foreign key errors if the data is not inserted in sequence.  To ensure data integrity some fine tuning maybe
		necessary for the test e.g extending http time out in the ligolwAPI when the system is very busy. 
		</UL>
		
		<P>The LDAS APIs affected by this test are:
		<UL>
		<LI><font color='blue'>managerAPI</font>: directs processing of the insertion user commands to the ligolwAPI and metadataAPI
			and returns the user command status to the user.</LI><p>
		<LI><font color='blue'>ligolwAPI</font>: 
			<UL>
			<LI>Retrieves the data to be ingested from the specified url to ilwd object and sends the ilwd
			to the metadataAPI for insertion.
			</UL><p>
		<LI><font color='blue'>metadataAPI</font>: 
			<UL>
			<LI>insert the metadata ilwd data from ligolwAPI into the specified database.</LI>
			</UL>
		</UL>
		
		
        <H2>Setup</H2>
        <P>Choose a directory to install the tests scripts.  
		<UL>
		<LI>The script files are:

        <P><CODE><font color='blue'>insertTrigs</font> - main driver script<BR><p>
        directory of dmt files  - download 
		<a href='http://www.ldas-sw.ligo.caltech.edu/packages/dmt-test.tar.gz'>sample dmt files</a>
		into a directory and untar and unzip the files 
		<pre><font color='blue'>tar xvzf dmt-test.tar.gz</font></pre>
		<font color='red'>Remove the tar ball (.gz file) from the directory since only xml files can be used.</font><p>
	 
		<font color='blue'>SeqInsert</font> - from ligotools<BR>
		</CODE></LI><p>
				
        <P><B>Note:</B> The above files should be installed on your local platform which should also have ligotools
		installed already. <p>
		To setup the environment for ligotools, login on a sun workstation and
		enter : <font color='blue'><pre>eval `/ligoapps/ligotools/bin/use_ligotools`</pre></font>
		Now cd to the scripts directory and run your test from this workstation.<CODE></CODE>.  
		</UL>
        <H2>Running the test</H2>
		The test should be run from your local platform, and run in the scripts directory.
		Before running the test, clear out any previous dmt data in the database you are going to do insertion
		by running the delall.sql script from ldas installation: e.g. <p>
		<pre><font color='blue'>
			db2 'connect to my_db'
			db2 -tf /ldas/doc/db2/doc/text/delall.sql 
			cd &lt;scripts directory&gt;
			tclsh insertTrigs cit ldas_tst ../triggers2 &gt;& cit.log &
		</font></pre>	
	
        <B>Usage:</B> <CODE>tclsh insertTrigs [options] >& insertTrigs.log & </CODE>

        <P><TABLE border=1 cellspacing=0 cellpadding=10>
            <TR>
                <TH><B>Option</B>
                <TH><B>Description</B>
            <TR>
                <TD valign=top><CODE>&lt;site&gt;</CODE>
                <TD>ldas site [ dev | test | lho | llo | mit ]<p>
					or &lt;mycomputer&gt;:10001
			<TR>
                <TD valign=top><CODE>&lt;dsname&gt;</CODE>
                <TD>database name at a site e.g. cit_test
			<TR>
                <TD valign=top><CODE>&lt;dmt triggers directory&gt;</CODE>
                <TD>directory holding dmt triggers xml files e.g. /home/john/triggers2	
        </TABLE><p>
		
		<p>
		<H2>Test Verification:</H2>
		The test should be monitored initially to make sure data is flowing in a steady pace and that the insertions
		are successful impling that data is inserted in the correct sequence.<p>
		<OL>
		<LI><font color='magenta'>Monitoring dmt</font><p>
			All output from script SeqInsert is captured to stdout which can be redirected to a file at startup e.g. cit.log.<p>
			A putMetaData user command is generated for each of the dmt files and sent to the managerAPI. The insertions
			can be monitored via cmonClient for the number of jobs and  the database insertions for the specified database. </LI>
		<p>
		<LI><font color='magenta'>Analysis</font><p>
			When all the xmls are sent to LDAS, the logs can be extracted via cmonClient Log page; enter the 
			gpstime ranges recorded in insertTrigs.log for logs in managerAPI, ligolwAPI and metadataAPI.
			Validate the following is true for successful insertions:
			<ul>
			<li>Number of files submitted by SeqInsert = number of xml files via unix command 
				<pre> grep -c submit &lt; insertTrigs log file &gt;  </pre></li>
			<li>Jobs statistics page should report the number sent by SeqInsert.</li><p>
			<li>Database statistics page should report the total number of insertions sent by SeqInsert.</li><p>
			<li>Number of gds_triggers inserted in database = number of gds_triggers in xml files <p>
				use guild query <p>
				<font color='blue'><pre>select count(*) from gds_trigger where process_id in 
(select process_id from process where program
in ('glitchMon', 'PSLmon'))</pre></font>
			to confirm this is the case.</li>
			<p>Other records inserted include process and segments. Also confirm this number in the database is the
			same as in xml files.
			</ul>
			<p>If there is a discrepancy search the logs for <font color='red'>red</font> balls to account for missing records.
			<p>Also examine the ldas database web page for the number of processes, segments and
			gds_triggers inserted to make sure they match the expected number.
			
			<p>If all the process and trigger data are inserted, the test <font color='green'>passes</font>. 
			If not, the test <font color='red'>fails</font> and the errors in the logs should account for all data received at LDAS.
		</OL>	
    </BODY>
</HTML>

